Index: trunk/LMDZ.TITAN/libf/muphytitan/asciiread.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/asciiread.f90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/asciiread.f90	(revision 3083)
@@ -1,39 +1,27 @@
-! Copyright Jérémie Burgalat (2010-2015,2017)
-! 
-! jeremie.burgalat@univ-reims.fr
-! 
-! This software is a computer program whose purpose is to provide configuration 
-! file and command line arguments parsing features to Fortran programs.
-! 
-! This software is governed by the CeCILL-B license under French law and
-! abiding by the rules of distribution of free software.  You can  use, 
-! modify and/ or redistribute the software under the terms of the CeCILL-B
-! license as circulated by CEA, CNRS and INRIA at the following URL
-! "http://www.cecill.info". 
-! 
-! As a counterpart to the access to the source code and  rights to copy,
-! modify and redistribute granted by the license, users are provided only
-! with a limited warranty  and the software's author,  the holder of the
-! economic rights,  and the successive licensors  have only  limited
-! liability. 
-! 
-! In this respect, the user's attention is drawn to the risks associated
-! with loading,  using,  modifying and/or developing or reproducing the
-! software by the user in light of its specific status of free software,
-! that may mean  that it is complicated to manipulate,  and  that  also
-! therefore means  that it is reserved for developers  and  experienced
-! professionals having in-depth computer knowledge. Users are therefore
-! encouraged to load and test the software's suitability as regards their
-! requirements in conditions enabling the security of their systems and/or 
-! data to be ensured and,  more generally, to use and operate it in the 
-! same conditions as regards security. 
-! 
-! The fact that you are presently reading this means that you have had
-! knowledge of the CeCILL-B license and that you accept its terms.
+! Copyright (c) (2013-2015,2017) Jeremie Burgalat (jeremie.burgalat@univ-reims.fr).
+!
+! This file is part of SWIFT
+!
+! Permission is hereby granted, free of charge, to any person obtaining a copy of
+! this software and associated documentation files (the "Software"), to deal in
+! the Software without restriction, including without limitation the rights to
+! use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
+! the Software, and to permit persons to whom the Software is furnished to do so,
+! subject to the following conditions:
+!
+! The above copyright notice and this permission notice shall be included in all
+! copies or substantial portions of the Software.
+!
+! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
+! FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
+! COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
+! IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+! CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 !! file: asciiread.f90
 !! summary: ASCII data file reader source file
 !! author: burgalat
-!! date: 2013-2015,2017
+!! date: 2013-2015,2017,2022
 MODULE ASCIIREAD
   !! ASCII data file reader module
@@ -42,5 +30,5 @@
   !! data array from ASCII file.
   !!
-  !! ``` 
+  !! ```
   !! FUNCTION read_data(path,data) RESULT(err)
   !! ```
@@ -56,9 +44,9 @@
   !!   - must use blank space(s) as value delimiter.
   !!   - must have a regular number of columns, that is each data line must
-  !!     have the same number of columns. 
+  !!     have the same number of columns.
   !!   - can contains any number of empty lines and/or comment line (i.e. line
   !!     where first non-blank character is "#"). All other lines are assumed
   !!     to be data.
-  !! Moreover, in the case of 3D data, it must use a SINGLE empty line for "depth" block separator.  
+  !! Moreover, in the case of 3D data, it must use a SINGLE empty line for "depth" block separator.
   !!
   !! Error occured when:
@@ -76,5 +64,5 @@
   !! of _R_ lines with _C_ columns. Each block must be separated by a single empty line
   !! and each columns must separated by one or more blank spaces (no tabulation ALLOWED).
-  !!  
+  !!
   !! On success, the shape of the 3D output array will be _data(R,C,D)_.
   USE, INTRINSIC :: ISO_FORTRAN_ENV, ONLY: IOSTAT_END, IOSTAT_EOR
@@ -93,5 +81,5 @@
   END INTERFACE
 
-  CONTAINS 
+  CONTAINS
 
 
@@ -100,13 +88,13 @@
     !!
     !! The function reads an ASCII file and saves its values in a real(kind=8) 3D-array.
-    !! 
+    !!
     !! The input file:
     !!
     !! - must have a regular number of columns, that is each data line must have the same number
-    !!   of columns (according to the delimiter used).  
+    !!   of columns (according to the delimiter used).
     !! - must use a SINGLE empty line for "depth" block separator.
     !! - can contains any number of comment lines (i.e. line where first non-blank character is "#").
     !!   All other lines (except empty lines) are assumed to be data.
-    !! 
+    !!
     !! Error occured when:
     !!    - Path does not refer to a existing file (-11)
@@ -118,8 +106,8 @@
     !! with _C_ columns. Each block must be separated by a single empty line and
     !! each columns must separated by one or more blank spaces (no tabulation ALLOWED).
-    !! 
+    !!
     !! On success, the shape of the 3D output array will be _output(R,C,D)_.
     !! On error, the 3D output array is __not allocated__.
-    CHARACTER(len=*), INTENT(in)                             :: path      !! Path of the input data file 
+    CHARACTER(len=*), INTENT(in)                             :: path      !! Path of the input data file
     REAL(kind=8), INTENT(out), DIMENSION(:,:,:), ALLOCATABLE :: data3d    !! 3D-array with the output values (double precision)
     CHARACTER(len=*), INTENT(in), OPTIONAL                   :: delimiter !! Optional column delimiter(s)
@@ -142,17 +130,17 @@
       err = error(trim(path)//": no such file",-1) ; RETURN
     ENDIF
-    lu = free_lun() 
+    lu = free_lun()
     IF (lu == -1) THEN ; err = error("Cannot find available logical unit...",-1) ; RETURN ; ENDIF
     ! Open file
     OPEN(lu,FILE=TRIM(path),STATUS='OLD',ACTION='READ')
 
-    ! First pass : 
+    ! First pass :
     ! ------------
-    !   - get size (rows, columns, depth) 
+    !   - get size (rows, columns, depth)
     !   - check size consistendcy
     !   - check value type
-    lc = 0 ; tlc = 0 
-    ndr = -1 ; ndc = -1 ; ndd = 1 
-    DO WHILE(readline(lu,line)) 
+    lc = 0 ; tlc = 0
+    ndr = -1 ; ndc = -1 ; ndd = 1
+    DO WHILE(readline(lu,line))
       lm1 = line
       ! Read the line
@@ -160,5 +148,5 @@
       ! skip comment line
       IF (INDEX(TRIM(ADJUSTL(line)),"#") == 1) CYCLE
-      ! An empty line: new 2D block 
+      ! An empty line: new 2D block
       IF (LEN_TRIM(line) == 0) THEN
         ndd = ndd + 1
@@ -175,5 +163,5 @@
       tlc = tlc + 1
       ! Splits line in words
-      IF (.NOT.tokenize(line,wrds,zdelim,.true.)) THEN 
+      IF (.NOT.tokenize(line,wrds,zdelim,.true.)) THEN
         ! cannot tokenize
         err = error(trim(path)//": Cannot parse line "//TRIM(slc),-5)
@@ -183,5 +171,5 @@
         err = error(trim(path)//": Cannot cast values at line "//TRIM(slc),-5)
         RETURN
-      ELSEIF (ndc > 0 .AND. ndc /= SIZE(wrds)) THEN 
+      ELSEIF (ndc > 0 .AND. ndc /= SIZE(wrds)) THEN
         ! current number of columns not equal to last one
         err = error(trim(path)//": Invalid number of columns (line "//TRIM(slc)//")",-5)
@@ -204,9 +192,9 @@
     ! Allocate memory
     ALLOCATE(data3d(ndr,ndc,ndd))
-    ir = 0 ; kd = 1 ; 
-    DO WHILE(readline(lu,line)) 
+    ir = 0 ; kd = 1 ;
+    DO WHILE(readline(lu,line))
       IF (INDEX(TRIM(ADJUSTL(line)),"#") == 1) CYCLE
       ir = ir + 1
-      ! empty line update block subscripts 
+      ! empty line update block subscripts
       IF (LEN_TRIM(line) == 0) THEN
         kd = kd + 1 ; ir = 0 ; CYCLE
@@ -223,13 +211,13 @@
     !!
     !! The function reads an ASCII file and saves its values in a real(kind=8) 2D-array.
-    !! 
+    !!
     !! The input file:
     !!
-    !! - can contains any number of empty lines and/or comment line (i.e. line where first 
+    !! - can contains any number of empty lines and/or comment line (i.e. line where first
     !!   non-blank character is "#"). All other lines are assumed to be data.
-    !! - must have a regular number of columns, that is each data line must have the same 
-    !!   number of columns. 
+    !! - must have a regular number of columns, that is each data line must have the same
+    !!   number of columns.
     !! - must use blank space(s) as value delimiter.
-    !! 
+    !!
     !! Error occured when:
     !!
@@ -241,5 +229,5 @@
     !! On error, the 2D output array is __not allocated__.
     USE FSYSTEM
-    CHARACTER(len=*), INTENT(in)                           :: path      !! Path of the input data file 
+    CHARACTER(len=*), INTENT(in)                           :: path      !! Path of the input data file
     REAL(kind=8), INTENT(out), DIMENSION(:,:), ALLOCATABLE :: data2d    !! 2D-array with the output values (double precision)
     CHARACTER(len=*), INTENT(in), OPTIONAL                 :: delimiter !! Optional column delimiter(s)
@@ -258,5 +246,5 @@
       err = error(trim(path)//": no such file",-1) ; RETURN
     ENDIF
-    lu = free_lun() 
+    lu = free_lun()
     IF (lu == -1) THEN ; err = error("Cannot find available logical unit...",-1) ; RETURN ; ENDIF
     OPEN(lu,FILE=TRIM(path),STATUS='OLD',ACTION='READ')
@@ -265,5 +253,5 @@
     lc=0 ; vc = 0 ; nc=-1
     ! First pass : get number of row values and checks everything !
-    DO 
+    DO
       ! Read the line
       IF (.NOT.readline(lu,line)) EXIT
@@ -273,5 +261,5 @@
       ! update row counter
       vc = vc + 1
-      IF (.NOT.tokenize(line,wrds,zdelim,.true.)) THEN 
+      IF (.NOT.tokenize(line,wrds,zdelim,.true.)) THEN
         ! cannot tokenize
         err = error(trim(path)//": Cannot parse line "//TRIM(slc),-5)
@@ -281,5 +269,5 @@
         err = error(trim(path)//": Cannot cast values at line "//TRIM(slc),-5)
         RETURN
-      ELSEIF (nc > 0 .AND. nc /= SIZE(tmp)) THEN 
+      ELSEIF (nc > 0 .AND. nc /= SIZE(tmp)) THEN
         ! current number of columns not equal to last one
         err = error(trim(path)//": Invalid number of columns (line "//TRIM(slc)//")",-5)
@@ -296,5 +284,5 @@
     ALLOCATE(data2d(nl,nc))
     ! Second pass : saves values :)
-    vc = 0 
+    vc = 0
     DO WHILE(vc <= nl)
       ! Reads the line
@@ -315,6 +303,6 @@
   FUNCTION readline(lun,line) RESULT(not_eof)
     !! Read a complete line
-    !! 
-    !! Each time, it is called, the function reads a complete of the file opened in __lun__ 
+    !!
+    !! Each time, it is called, the function reads a complete of the file opened in __lun__
     !! logical unit and returns .false. if EOF has been reached, .true. otherwise.
     !!
@@ -331,6 +319,6 @@
     !! CLOSE(1)
     !! ```
-    INTEGER, INTENT(in)                        :: lun  !! Logical unit with the opened file to read. 
-    CHARACTER(len=:), ALLOCATABLE, INTENT(out) :: line !! Processed line 
+    INTEGER, INTENT(in)                        :: lun  !! Logical unit with the opened file to read.
+    CHARACTER(len=:), ALLOCATABLE, INTENT(out) :: line !! Processed line
     LOGICAL  :: not_eof                                !! .true. if EOF has NOT been reached yet, .false. otherwise
     CHARACTER(len=50) :: buf
Index: trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90	(revision 3083)
@@ -1,39 +1,27 @@
-! Copyright Jérémie Burgalat (2010-2015,2017)
+! Copyright (c) (2013-2015,2017) Jeremie Burgalat (jeremie.burgalat@univ-reims.fr).
 !
-! jeremie.burgalat@univ-reims.fr
+! This file is part of SWIFT
 !
-! This software is a computer program whose purpose is to provide configuration
-! file and command line arguments parsing features to Fortran programs.
+! Permission is hereby granted, free of charge, to any person obtaining a copy of
+! this software and associated documentation files (the "Software"), to deal in
+! the Software without restriction, including without limitation the rights to
+! use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
+! the Software, and to permit persons to whom the Software is furnished to do so,
+! subject to the following conditions:
 !
-! This software is governed by the CeCILL-B license under French law and
-! abiding by the rules of distribution of free software.  You can  use,
-! modify and/ or redistribute the software under the terms of the CeCILL-B
-! license as circulated by CEA, CNRS and INRIA at the following URL
-! "http://www.cecill.info".
+! The above copyright notice and this permission notice shall be included in all
+! copies or substantial portions of the Software.
 !
-! As a counterpart to the access to the source code and  rights to copy,
-! modify and redistribute granted by the license, users are provided only
-! with a limited warranty  and the software's author,  the holder of the
-! economic rights,  and the successive licensors  have only  limited
-! liability.
-!
-! In this respect, the user's attention is drawn to the risks associated
-! with loading,  using,  modifying and/or developing or reproducing the
-! software by the user in light of its specific status of free software,
-! that may mean  that it is complicated to manipulate,  and  that  also
-! therefore means  that it is reserved for developers  and  experienced
-! professionals having in-depth computer knowledge. Users are therefore
-! encouraged to load and test the software's suitability as regards their
-! requirements in conditions enabling the security of their systems and/or
-! data to be ensured and,  more generally, to use and operate it in the
-! same conditions as regards security.
-!
-! The fact that you are presently reading this means that you have had
-! knowledge of the CeCILL-B license and that you accept its terms.
+! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
+! FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
+! COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
+! IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+! CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 !! file: cfgparse.F90
 !! summary: Configuration file parser source file.
 !! author: J. Burgalat
-!! date: 2013-2015,2017
+!! date: 2013-2015,2017,2022
 
 #include "defined.h"
@@ -330,5 +318,5 @@
     oname = zsname//"/"//zpname
     IF (PRESENT(sname)) sname = zsname
-    IF (PRESENT(pname)) pname = zpname 
+    IF (PRESENT(pname)) pname = zpname
   END FUNCTION op_format
 
@@ -418,5 +406,5 @@
     !!
     !! Otherwise it is assumed to be the basename of the option.
-    !! 
+    !!
     !! A valid option (base) name is an alphanumeric sequence in lower-case that always begin by
     !! a letter.
@@ -479,5 +467,5 @@
     IF(.NOT.ALLOCATED(this%options)) RETURN
     IF (.NOT.PRESENT(section)) THEN
-      num = SIZE(this%options)  
+      num = SIZE(this%options)
     ELSE
       DO i=1, SIZE(this%options)
Index: trunk/LMDZ.TITAN/libf/muphytitan/csystem.c
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/csystem.c	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/csystem.c	(revision 3083)
@@ -1,34 +1,23 @@
-/* Copyright Jérémie Burgalat (2010-2015,2017)
- * 
- * jeremie.burgalat@univ-reims.fr
- * 
- * This software is a computer program whose purpose is to provide configuration 
- * file and command line arguments parsing features to Fortran programs.
- * 
- * This software is governed by the CeCILL-B license under French law and
- * abiding by the rules of distribution of free software.  You can  use, 
- * modify and/ or redistribute the software under the terms of the CeCILL-B
- * license as circulated by CEA, CNRS and INRIA at the following URL
- * "http://www.cecill.info". 
- * 
- * As a counterpart to the access to the source code and  rights to copy,
- * modify and redistribute granted by the license, users are provided only
- * with a limited warranty  and the software's author,  the holder of the
- * economic rights,  and the successive licensors  have only  limited
- * liability. 
- * 
- * In this respect, the user's attention is drawn to the risks associated
- * with loading,  using,  modifying and/or developing or reproducing the
- * software by the user in light of its specific status of free software,
- * that may mean  that it is complicated to manipulate,  and  that  also
- * therefore means  that it is reserved for developers  and  experienced
- * professionals having in-depth computer knowledge. Users are therefore
- * encouraged to load and test the software's suitability as regards their
- * requirements in conditions enabling the security of their systems and/or 
- * data to be ensured and,  more generally, to use and operate it in the 
- * same conditions as regards security. 
- * 
- * The fact that you are presently reading this means that you have had
- * knowledge of the CeCILL-B license and that you accept its terms.
+/*
+ * Copyright (c) (2013-2015,2017) Jeremie Burgalat (jeremie.burgalat@univ-reims.fr).
+ *
+ * This file is part of SWIFT
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy of
+ * this software and associated documentation files (the "Software"), to deal in
+ * the Software without restriction, including without limitation the rights to
+ * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
+ * the Software, and to permit persons to whom the Software is furnished to do so,
+ * subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in all
+ * copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
+ * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
+ * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
+ * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+ * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  */
 
@@ -71,10 +60,10 @@
     free(tmp);
     tmp = NULL;
-  } 
+  }
   return tmp;
 }
 
 
-/* Get the realpath of input path and saves it in output path */ 
+/* Get the realpath of input path and saves it in output path */
 char* c_realpath(const char *input){
   if (!strlen(input)) {
@@ -148,5 +137,5 @@
         continue;
       }
-      len = path_len + strlen(p->d_name) + 2; 
+      len = path_len + strlen(p->d_name) + 2;
       buf = malloc(len);
       if (buf) {
@@ -168,5 +157,5 @@
   if (!r) {
     r = rmdir(path);
-	return r?errno:0;
+  return r?errno:0;
   }
   return r;
@@ -174,5 +163,5 @@
 
 /* Get some file informations */
-int c_fstat(const char *p, int *pe, int *nl, int *ty, int *ui, int *gi, 
+int c_fstat(const char *p, int *pe, int *nl, int *ty, int *ui, int *gi,
             long *si, char a[20], char m[20], char c[20]){
   struct stat stb;
@@ -189,5 +178,5 @@
     else *ty = 4;
     *ui = (int)stb.st_uid ; *gi = (int)stb.st_gid ; *si = (long)stb.st_size ;
-    t = localtime(&stb.st_atime) ; ret = strftime(tmp, 20, "%F,%T", t); 
+    t = localtime(&stb.st_atime) ; ret = strftime(tmp, 20, "%F,%T", t);
     if(ret != 0) {strncpy(a,tmp,20); a[19] = '\0';}else{a[0] = '\0';}
     t = localtime(&stb.st_mtime) ; ret = strftime(tmp, 20, "%F,%T", t);
@@ -212,5 +201,5 @@
     if (forced){
       p = strdup(path) ; if(p == NULL) {return errno;}
-      d = dirname(p) ; free(p) ; 
+      d = dirname(p) ; free(p) ;
       if(d == NULL) {return -9;}
       // we attempts to create parent directory first
@@ -218,10 +207,10 @@
       perm =((S_IRWXU | S_IRWXG | S_IRWXO) & ~(cmask & ~(S_IWUSR | S_IXUSR)));
       (void)umask(cmask) ;
-      eval = c_mkdirp(d,perm); 
+      eval = c_mkdirp(d,perm);
       if(eval){return eval;}
     }
     eval = open(path,O_CREAT|O_EXCL,mode);
     if (eval == -1) {eval=errno;}else{close(eval);eval=0;}
-  }  
+  }
   return eval ;
 }
@@ -355,5 +344,5 @@
  *  Copyright (c) 1983, 1992, 1993
  *   The Regents of the University of California.  All rights reserved.
- * 
+ *
  *  Redistribution and use in source and binary forms, with or without
  *  modification, are permitted provided that the following conditions
@@ -371,5 +360,5 @@
  *     may be used to endorse or promote products derived from this software
  *     without specific prior written permission.
- * 
+ *
  *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
  *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
@@ -416,5 +405,5 @@
         retval = 1; break;
       }
-    } 
+    }
     if (!last) *p = '/';
   }
@@ -433,5 +422,5 @@
  *
  * @APPLE_LICENSE_HEADER_START@
- * 
+ *
  * "Portions Copyright (c) 1999 Apple Computer, Inc.  All Rights
  * Reserved.  This file contains Original Code and/or Modifications of
@@ -441,5 +430,5 @@
  * License at http://www.apple.com/publicsource and read it before using
  * this file.
- * 
+ *
  * The Original Code and all software distributed under the License are
  * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
@@ -449,5 +438,5 @@
  * License for the specific language governing rights and limitations
  * under the License."
- * 
+ *
  * @APPLE_LICENSE_HEADER_END@
  *
@@ -467,25 +456,25 @@
   buf = NULL;
 
-  if (realpath(reldir,start_path) == NULL) 
+  if (realpath(reldir,start_path) == NULL)
     return buf;
-  
-  if (realpath(path,end_path) == NULL) 
+
+  if (realpath(path,end_path) == NULL)
     return buf;
 
   // stat the starting path
-  if (stat(start_path, &st) < 0) 
+  if (stat(start_path, &st) < 0)
     return buf;
-  
+
   if ((st.st_mode & S_IFMT) != S_IFDIR) {
     errno = ENOTDIR;
     return buf;
-  } 
+  }
   if (start_path[strlen(start_path) - 1] != '/')
     strcat(start_path, "/");
 
   // stat the ending path path
-  if (stat(end_path, &st) < 0) 
+  if (stat(end_path, &st) < 0)
     return buf;
-  
+
   if ((st.st_mode & S_IFMT) == S_IFDIR
       && end_path[strlen(end_path) - 1] != '/')
@@ -624,7 +613,7 @@
 #elif defined(__APPLE__) && defined(__MACH__)
     /* OSX ------------------------------------------------------ */
-    struct mach_task_basic_info info;
-    mach_msg_type_number_t infoCount = MACH_TASK_BASIC_INFO_COUNT;
-    if (task_info(mach_task_self(), MACH_TASK_BASIC_INFO, (task_info_t)&info, &infoCount) != KERN_SUCCESS)
+    struct task_basic_info info;
+    mach_msg_type_number_t infoCount = TASK_BASIC_INFO_COUNT;
+    if (task_info(mach_task_self(), TASK_BASIC_INFO, (task_info_t)&info, &infoCount) != KERN_SUCCESS)
         return (size_t)0L; /* Can't access? */
     return (size_t)info.resident_size;
@@ -650,5 +639,5 @@
 
 
- 
+
 /* Get some informatiosn about the OS memory usage (from /proc/meminfo) */
 int c_getSystemMemory(long long int *m_total,long long int *m_available,long long int *m_free){
@@ -661,9 +650,10 @@
     if (m_available) (*m_free) = mem2;
     if (m_free) (*m_free) = mem3;
-    if ((fp = fopen("/proc/meminfo", "r")) == NULL)  
+    if ((fp = fopen("/proc/meminfo", "r")) == NULL)
         return 1;
     while (fgets(buf, sizeof(buf), fp) != NULL){
-        ts = strlen(buf) - 1; buf[ts] = '\0'; 
-        tmp = strndup(&buf[0],ts);
+        ts = strlen(buf) - 1; buf[ts] = '\0';
+        tmp = strdup(&buf[0]);
+        //tmp = strndup(&buf[0],ts); // GNU extension
         // check our 3 cases
         if (ts >= 9 && !strncmp(tmp,"MemTotal:",9)){
@@ -674,9 +664,9 @@
         }
         if (ts >= 13 && !strncmp(tmp,"MemAvailable:",13)){
-            p=strtok(tmp, " "); p=strtok(NULL, " "); 
+            p=strtok(tmp, " "); p=strtok(NULL, " ");
             mem2 = strtoll(p,NULL,10);
-        }    
+        }
         if (ts >= 8 && !strncmp(tmp,"MemFree:",8)){
-            p=strtok(tmp, " "); p=strtok(NULL, " "); 
+            p=strtok(tmp, " "); p=strtok(NULL, " ");
             mem3 = strtoll(p,NULL,10);
         }
